/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import type { AccountResponse, AccountsResponse, PostAccountWrapper } from '../models/index';
export interface CreateAccountRequest {
    budgetId: string;
    data: PostAccountWrapper;
}
export interface GetAccountByIdRequest {
    budgetId: string;
    accountId: string;
}
export interface GetAccountsRequest {
    budgetId: string;
    lastKnowledgeOfServer?: number;
}
/**
 *
 */
export declare class AccountsApi extends runtime.BaseAPI {
    /**
     * Creates a new account
     * Create a new account
     */
    createAccountRaw(requestParameters: CreateAccountRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<AccountResponse>>;
    /**
     * Creates a new account
     * Create a new account
     */
    createAccount(budgetId: string, data: PostAccountWrapper, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<AccountResponse>;
    /**
     * Returns a single account
     * Single account
     */
    getAccountByIdRaw(requestParameters: GetAccountByIdRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<AccountResponse>>;
    /**
     * Returns a single account
     * Single account
     */
    getAccountById(budgetId: string, accountId: string, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<AccountResponse>;
    /**
     * Returns all accounts
     * Account list
     */
    getAccountsRaw(requestParameters: GetAccountsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<AccountsResponse>>;
    /**
     * Returns all accounts
     * Account list
     */
    getAccounts(budgetId: string, lastKnowledgeOfServer?: number, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<AccountsResponse>;
}
