/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import type { PayeeLocationResponse, PayeeLocationsResponse } from '../models/index';
export interface GetPayeeLocationByIdRequest {
    budgetId: string;
    payeeLocationId: string;
}
export interface GetPayeeLocationsRequest {
    budgetId: string;
}
export interface GetPayeeLocationsByPayeeRequest {
    budgetId: string;
    payeeId: string;
}
/**
 *
 */
export declare class PayeeLocationsApi extends runtime.BaseAPI {
    /**
     * Returns a single payee location
     * Single payee location
     */
    getPayeeLocationByIdRaw(requestParameters: GetPayeeLocationByIdRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<PayeeLocationResponse>>;
    /**
     * Returns a single payee location
     * Single payee location
     */
    getPayeeLocationById(budgetId: string, payeeLocationId: string, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<PayeeLocationResponse>;
    /**
     * Returns all payee locations
     * List payee locations
     */
    getPayeeLocationsRaw(requestParameters: GetPayeeLocationsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<PayeeLocationsResponse>>;
    /**
     * Returns all payee locations
     * List payee locations
     */
    getPayeeLocations(budgetId: string, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<PayeeLocationsResponse>;
    /**
     * Returns all payee locations for a specified payee
     * List locations for a payee
     */
    getPayeeLocationsByPayeeRaw(requestParameters: GetPayeeLocationsByPayeeRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<PayeeLocationsResponse>>;
    /**
     * Returns all payee locations for a specified payee
     * List locations for a payee
     */
    getPayeeLocationsByPayee(budgetId: string, payeeId: string, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<PayeeLocationsResponse>;
}
