/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { AccountType } from './AccountType';
/**
 *
 * @export
 * @interface Account
 */
export interface Account {
    /**
     *
     * @type {string}
     * @memberof Account
     */
    id: string;
    /**
     *
     * @type {string}
     * @memberof Account
     */
    name: string;
    /**
     *
     * @type {AccountType}
     * @memberof Account
     */
    type: AccountType;
    /**
     * Whether this account is on budget or not
     * @type {boolean}
     * @memberof Account
     */
    on_budget: boolean;
    /**
     * Whether this account is closed or not
     * @type {boolean}
     * @memberof Account
     */
    closed: boolean;
    /**
     *
     * @type {string}
     * @memberof Account
     */
    note?: string | null;
    /**
     * The current balance of the account in milliunits format
     * @type {number}
     * @memberof Account
     */
    balance: number;
    /**
     * The current cleared balance of the account in milliunits format
     * @type {number}
     * @memberof Account
     */
    cleared_balance: number;
    /**
     * The current uncleared balance of the account in milliunits format
     * @type {number}
     * @memberof Account
     */
    uncleared_balance: number;
    /**
     * The payee id which should be used when transferring to this account
     * @type {string}
     * @memberof Account
     */
    transfer_payee_id: string | null;
    /**
     * Whether or not the account is linked to a financial institution for automatic transaction import.
     * @type {boolean}
     * @memberof Account
     */
    direct_import_linked?: boolean;
    /**
     * If an account linked to a financial institution (direct_import_linked=true) and the linked connection is not in a healthy state, this will be true.
     * @type {boolean}
     * @memberof Account
     */
    direct_import_in_error?: boolean;
    /**
     * A date/time specifying when the account was last reconciled.
     * @type {string}
     * @memberof Account
     */
    last_reconciled_at?: string | null;
    /**
     * The original debt/loan account balance, specified in milliunits format.
     * @type {number}
     * @memberof Account
     */
    debt_original_balance?: number | null;
    /**
     *
     * @type {{ [key: string]: number; }}
     * @memberof Account
     */
    debt_interest_rates?: {
        [key: string]: number;
    } | null;
    /**
     *
     * @type {{ [key: string]: number; }}
     * @memberof Account
     */
    debt_minimum_payments?: {
        [key: string]: number;
    } | null;
    /**
     *
     * @type {{ [key: string]: number; }}
     * @memberof Account
     */
    debt_escrow_amounts?: {
        [key: string]: number;
    } | null;
    /**
     * Whether or not the account has been deleted.  Deleted accounts will only be included in delta requests.
     * @type {boolean}
     * @memberof Account
     */
    deleted: boolean;
}
/**
 * Check if a given object implements the Account interface.
 */
export declare function instanceOfAccount(value: object): boolean;
export declare function AccountFromJSON(json: any): Account;
export declare function AccountFromJSONTyped(json: any, ignoreDiscriminator: boolean): Account;
export declare function AccountToJSON(value?: Account | null): any;
