/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface ScheduledSubTransaction
 */
export interface ScheduledSubTransaction {
    /**
     *
     * @type {string}
     * @memberof ScheduledSubTransaction
     */
    id: string;
    /**
     *
     * @type {string}
     * @memberof ScheduledSubTransaction
     */
    scheduled_transaction_id: string;
    /**
     * The scheduled subtransaction amount in milliunits format
     * @type {number}
     * @memberof ScheduledSubTransaction
     */
    amount: number;
    /**
     *
     * @type {string}
     * @memberof ScheduledSubTransaction
     */
    memo?: string | null;
    /**
     *
     * @type {string}
     * @memberof ScheduledSubTransaction
     */
    payee_id?: string | null;
    /**
     *
     * @type {string}
     * @memberof ScheduledSubTransaction
     */
    category_id?: string | null;
    /**
     * If a transfer, the account_id which the scheduled subtransaction transfers to
     * @type {string}
     * @memberof ScheduledSubTransaction
     */
    transfer_account_id?: string | null;
    /**
     * Whether or not the scheduled subtransaction has been deleted. Deleted scheduled subtransactions will only be included in delta requests.
     * @type {boolean}
     * @memberof ScheduledSubTransaction
     */
    deleted: boolean;
}
/**
 * Check if a given object implements the ScheduledSubTransaction interface.
 */
export declare function instanceOfScheduledSubTransaction(value: object): boolean;
export declare function ScheduledSubTransactionFromJSON(json: any): ScheduledSubTransaction;
export declare function ScheduledSubTransactionFromJSONTyped(json: any, ignoreDiscriminator: boolean): ScheduledSubTransaction;
export declare function ScheduledSubTransactionToJSON(value?: ScheduledSubTransaction | null): any;
