/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { ScheduledSubTransaction } from './ScheduledSubTransaction';
import type { TransactionFlagColor } from './TransactionFlagColor';
/**
 *
 * @export
 * @interface ScheduledTransactionDetail
 */
export interface ScheduledTransactionDetail {
    /**
     *
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    id: string;
    /**
     * The first date for which the Scheduled Transaction was scheduled.
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    date_first: string;
    /**
     * The next date for which the Scheduled Transaction is scheduled.
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    date_next: string;
    /**
     *
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    frequency: ScheduledTransactionDetailFrequencyEnum;
    /**
     * The scheduled transaction amount in milliunits format
     * @type {number}
     * @memberof ScheduledTransactionDetail
     */
    amount: number;
    /**
     *
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    memo?: string | null;
    /**
     *
     * @type {TransactionFlagColor}
     * @memberof ScheduledTransactionDetail
     */
    flag_color?: TransactionFlagColor | null;
    /**
     *
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    account_id: string;
    /**
     *
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    payee_id?: string | null;
    /**
     *
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    category_id?: string | null;
    /**
     * If a transfer, the account_id which the scheduled transaction transfers to
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    transfer_account_id?: string | null;
    /**
     * Whether or not the scheduled transaction has been deleted.  Deleted scheduled transactions will only be included in delta requests.
     * @type {boolean}
     * @memberof ScheduledTransactionDetail
     */
    deleted: boolean;
    /**
     *
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    account_name: string;
    /**
     *
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    payee_name?: string | null;
    /**
     * The name of the category.  If a split scheduled transaction, this will be 'Split'.
     * @type {string}
     * @memberof ScheduledTransactionDetail
     */
    category_name?: string | null;
    /**
     * If a split scheduled transaction, the subtransactions.
     * @type {Array<ScheduledSubTransaction>}
     * @memberof ScheduledTransactionDetail
     */
    subtransactions: Array<ScheduledSubTransaction>;
}
/**
 * @export
 */
export declare const ScheduledTransactionDetailFrequencyEnum: {
    readonly Never: "never";
    readonly Daily: "daily";
    readonly Weekly: "weekly";
    readonly EveryOtherWeek: "everyOtherWeek";
    readonly TwiceAMonth: "twiceAMonth";
    readonly Every4Weeks: "every4Weeks";
    readonly Monthly: "monthly";
    readonly EveryOtherMonth: "everyOtherMonth";
    readonly Every3Months: "every3Months";
    readonly Every4Months: "every4Months";
    readonly TwiceAYear: "twiceAYear";
    readonly Yearly: "yearly";
    readonly EveryOtherYear: "everyOtherYear";
};
export declare type ScheduledTransactionDetailFrequencyEnum = typeof ScheduledTransactionDetailFrequencyEnum[keyof typeof ScheduledTransactionDetailFrequencyEnum];
/**
 * Check if a given object implements the ScheduledTransactionDetail interface.
 */
export declare function instanceOfScheduledTransactionDetail(value: object): boolean;
export declare function ScheduledTransactionDetailFromJSON(json: any): ScheduledTransactionDetail;
export declare function ScheduledTransactionDetailFromJSONTyped(json: any, ignoreDiscriminator: boolean): ScheduledTransactionDetail;
export declare function ScheduledTransactionDetailToJSON(value?: ScheduledTransactionDetail | null): any;
