/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface SubTransaction
 */
export interface SubTransaction {
    /**
     *
     * @type {string}
     * @memberof SubTransaction
     */
    id: string;
    /**
     *
     * @type {string}
     * @memberof SubTransaction
     */
    transaction_id: string;
    /**
     * The subtransaction amount in milliunits format
     * @type {number}
     * @memberof SubTransaction
     */
    amount: number;
    /**
     *
     * @type {string}
     * @memberof SubTransaction
     */
    memo?: string | null;
    /**
     *
     * @type {string}
     * @memberof SubTransaction
     */
    payee_id?: string | null;
    /**
     *
     * @type {string}
     * @memberof SubTransaction
     */
    payee_name?: string | null;
    /**
     *
     * @type {string}
     * @memberof SubTransaction
     */
    category_id?: string | null;
    /**
     *
     * @type {string}
     * @memberof SubTransaction
     */
    category_name?: string | null;
    /**
     * If a transfer, the account_id which the subtransaction transfers to
     * @type {string}
     * @memberof SubTransaction
     */
    transfer_account_id?: string | null;
    /**
     * If a transfer, the id of transaction on the other side of the transfer
     * @type {string}
     * @memberof SubTransaction
     */
    transfer_transaction_id?: string | null;
    /**
     * Whether or not the subtransaction has been deleted.  Deleted subtransactions will only be included in delta requests.
     * @type {boolean}
     * @memberof SubTransaction
     */
    deleted: boolean;
}
/**
 * Check if a given object implements the SubTransaction interface.
 */
export declare function instanceOfSubTransaction(value: object): boolean;
export declare function SubTransactionFromJSON(json: any): SubTransaction;
export declare function SubTransactionFromJSONTyped(json: any, ignoreDiscriminator: boolean): SubTransaction;
export declare function SubTransactionToJSON(value?: SubTransaction | null): any;
