/* tslint:disable */
/* eslint-disable */
/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { exists } from '../runtime';
import { SubTransactionFromJSON, SubTransactionToJSON, } from './SubTransaction';
import { TransactionClearedStatusFromJSON, TransactionClearedStatusToJSON, } from './TransactionClearedStatus';
import { TransactionFlagColorFromJSON, TransactionFlagColorToJSON, } from './TransactionFlagColor';
/**
 * @export
 */
export var TransactionDetailDebtTransactionTypeEnum = {
    Payment: 'payment',
    Refund: 'refund',
    Fee: 'fee',
    Interest: 'interest',
    Escrow: 'escrow',
    BalanceAdjustment: 'balanceAdjustment',
    Credit: 'credit',
    Charge: 'charge',
};
/**
 * Check if a given object implements the TransactionDetail interface.
 */
export function instanceOfTransactionDetail(value) {
    var isInstance = true;
    isInstance = isInstance && "id" in value;
    isInstance = isInstance && "date" in value;
    isInstance = isInstance && "amount" in value;
    isInstance = isInstance && "cleared" in value;
    isInstance = isInstance && "approved" in value;
    isInstance = isInstance && "account_id" in value;
    isInstance = isInstance && "deleted" in value;
    isInstance = isInstance && "account_name" in value;
    isInstance = isInstance && "subtransactions" in value;
    return isInstance;
}
export function TransactionDetailFromJSON(json) {
    return TransactionDetailFromJSONTyped(json, false);
}
export function TransactionDetailFromJSONTyped(json, ignoreDiscriminator) {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        'id': json['id'],
        'date': json['date'],
        'amount': json['amount'],
        'memo': !exists(json, 'memo') ? undefined : json['memo'],
        'cleared': TransactionClearedStatusFromJSON(json['cleared']),
        'approved': json['approved'],
        'flag_color': !exists(json, 'flag_color') ? undefined : TransactionFlagColorFromJSON(json['flag_color']),
        'account_id': json['account_id'],
        'payee_id': !exists(json, 'payee_id') ? undefined : json['payee_id'],
        'category_id': !exists(json, 'category_id') ? undefined : json['category_id'],
        'transfer_account_id': !exists(json, 'transfer_account_id') ? undefined : json['transfer_account_id'],
        'transfer_transaction_id': !exists(json, 'transfer_transaction_id') ? undefined : json['transfer_transaction_id'],
        'matched_transaction_id': !exists(json, 'matched_transaction_id') ? undefined : json['matched_transaction_id'],
        'import_id': !exists(json, 'import_id') ? undefined : json['import_id'],
        'import_payee_name': !exists(json, 'import_payee_name') ? undefined : json['import_payee_name'],
        'import_payee_name_original': !exists(json, 'import_payee_name_original') ? undefined : json['import_payee_name_original'],
        'debt_transaction_type': !exists(json, 'debt_transaction_type') ? undefined : json['debt_transaction_type'],
        'deleted': json['deleted'],
        'account_name': json['account_name'],
        'payee_name': !exists(json, 'payee_name') ? undefined : json['payee_name'],
        'category_name': !exists(json, 'category_name') ? undefined : json['category_name'],
        'subtransactions': (json['subtransactions'].map(SubTransactionFromJSON)),
    };
}
export function TransactionDetailToJSON(value) {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        'id': value.id,
        'date': value.date,
        'amount': value.amount,
        'memo': value.memo,
        'cleared': TransactionClearedStatusToJSON(value.cleared),
        'approved': value.approved,
        'flag_color': TransactionFlagColorToJSON(value.flag_color),
        'account_id': value.account_id,
        'payee_id': value.payee_id,
        'category_id': value.category_id,
        'transfer_account_id': value.transfer_account_id,
        'transfer_transaction_id': value.transfer_transaction_id,
        'matched_transaction_id': value.matched_transaction_id,
        'import_id': value.import_id,
        'import_payee_name': value.import_payee_name,
        'import_payee_name_original': value.import_payee_name_original,
        'debt_transaction_type': value.debt_transaction_type,
        'deleted': value.deleted,
        'account_name': value.account_name,
        'payee_name': value.payee_name,
        'category_name': value.category_name,
        'subtransactions': (value.subtransactions.map(SubTransactionToJSON)),
    };
}
