"use strict";
/* tslint:disable */
/* eslint-disable */
/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.BudgetDetailToJSON = exports.BudgetDetailFromJSONTyped = exports.BudgetDetailFromJSON = exports.instanceOfBudgetDetail = void 0;
const runtime_1 = require("../runtime");
const Account_1 = require("./Account");
const Category_1 = require("./Category");
const CategoryGroup_1 = require("./CategoryGroup");
const CurrencyFormat_1 = require("./CurrencyFormat");
const DateFormat_1 = require("./DateFormat");
const MonthDetail_1 = require("./MonthDetail");
const Payee_1 = require("./Payee");
const PayeeLocation_1 = require("./PayeeLocation");
const ScheduledSubTransaction_1 = require("./ScheduledSubTransaction");
const ScheduledTransactionSummary_1 = require("./ScheduledTransactionSummary");
const SubTransaction_1 = require("./SubTransaction");
const TransactionSummary_1 = require("./TransactionSummary");
/**
 * Check if a given object implements the BudgetDetail interface.
 */
function instanceOfBudgetDetail(value) {
    let isInstance = true;
    isInstance = isInstance && "id" in value;
    isInstance = isInstance && "name" in value;
    return isInstance;
}
exports.instanceOfBudgetDetail = instanceOfBudgetDetail;
function BudgetDetailFromJSON(json) {
    return BudgetDetailFromJSONTyped(json, false);
}
exports.BudgetDetailFromJSON = BudgetDetailFromJSON;
function BudgetDetailFromJSONTyped(json, ignoreDiscriminator) {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        'id': json['id'],
        'name': json['name'],
        'last_modified_on': !(0, runtime_1.exists)(json, 'last_modified_on') ? undefined : json['last_modified_on'],
        'first_month': !(0, runtime_1.exists)(json, 'first_month') ? undefined : json['first_month'],
        'last_month': !(0, runtime_1.exists)(json, 'last_month') ? undefined : json['last_month'],
        'date_format': !(0, runtime_1.exists)(json, 'date_format') ? undefined : (0, DateFormat_1.DateFormatFromJSON)(json['date_format']),
        'currency_format': !(0, runtime_1.exists)(json, 'currency_format') ? undefined : (0, CurrencyFormat_1.CurrencyFormatFromJSON)(json['currency_format']),
        'accounts': !(0, runtime_1.exists)(json, 'accounts') ? undefined : (json['accounts'].map(Account_1.AccountFromJSON)),
        'payees': !(0, runtime_1.exists)(json, 'payees') ? undefined : (json['payees'].map(Payee_1.PayeeFromJSON)),
        'payee_locations': !(0, runtime_1.exists)(json, 'payee_locations') ? undefined : (json['payee_locations'].map(PayeeLocation_1.PayeeLocationFromJSON)),
        'category_groups': !(0, runtime_1.exists)(json, 'category_groups') ? undefined : (json['category_groups'].map(CategoryGroup_1.CategoryGroupFromJSON)),
        'categories': !(0, runtime_1.exists)(json, 'categories') ? undefined : (json['categories'].map(Category_1.CategoryFromJSON)),
        'months': !(0, runtime_1.exists)(json, 'months') ? undefined : (json['months'].map(MonthDetail_1.MonthDetailFromJSON)),
        'transactions': !(0, runtime_1.exists)(json, 'transactions') ? undefined : (json['transactions'].map(TransactionSummary_1.TransactionSummaryFromJSON)),
        'subtransactions': !(0, runtime_1.exists)(json, 'subtransactions') ? undefined : (json['subtransactions'].map(SubTransaction_1.SubTransactionFromJSON)),
        'scheduled_transactions': !(0, runtime_1.exists)(json, 'scheduled_transactions') ? undefined : (json['scheduled_transactions'].map(ScheduledTransactionSummary_1.ScheduledTransactionSummaryFromJSON)),
        'scheduled_subtransactions': !(0, runtime_1.exists)(json, 'scheduled_subtransactions') ? undefined : (json['scheduled_subtransactions'].map(ScheduledSubTransaction_1.ScheduledSubTransactionFromJSON)),
    };
}
exports.BudgetDetailFromJSONTyped = BudgetDetailFromJSONTyped;
function BudgetDetailToJSON(value) {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        'id': value.id,
        'name': value.name,
        'last_modified_on': value.last_modified_on,
        'first_month': value.first_month,
        'last_month': value.last_month,
        'date_format': (0, DateFormat_1.DateFormatToJSON)(value.date_format),
        'currency_format': (0, CurrencyFormat_1.CurrencyFormatToJSON)(value.currency_format),
        'accounts': value.accounts === undefined ? undefined : (value.accounts.map(Account_1.AccountToJSON)),
        'payees': value.payees === undefined ? undefined : (value.payees.map(Payee_1.PayeeToJSON)),
        'payee_locations': value.payee_locations === undefined ? undefined : (value.payee_locations.map(PayeeLocation_1.PayeeLocationToJSON)),
        'category_groups': value.category_groups === undefined ? undefined : (value.category_groups.map(CategoryGroup_1.CategoryGroupToJSON)),
        'categories': value.categories === undefined ? undefined : (value.categories.map(Category_1.CategoryToJSON)),
        'months': value.months === undefined ? undefined : (value.months.map(MonthDetail_1.MonthDetailToJSON)),
        'transactions': value.transactions === undefined ? undefined : (value.transactions.map(TransactionSummary_1.TransactionSummaryToJSON)),
        'subtransactions': value.subtransactions === undefined ? undefined : (value.subtransactions.map(SubTransaction_1.SubTransactionToJSON)),
        'scheduled_transactions': value.scheduled_transactions === undefined ? undefined : (value.scheduled_transactions.map(ScheduledTransactionSummary_1.ScheduledTransactionSummaryToJSON)),
        'scheduled_subtransactions': value.scheduled_subtransactions === undefined ? undefined : (value.scheduled_subtransactions.map(ScheduledSubTransaction_1.ScheduledSubTransactionToJSON)),
    };
}
exports.BudgetDetailToJSON = BudgetDetailToJSON;
