/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Account } from './Account';
import type { Category } from './Category';
import type { CategoryGroup } from './CategoryGroup';
import type { MonthDetail } from './MonthDetail';
import type { Payee } from './Payee';
import type { PayeeLocation } from './PayeeLocation';
import type { ScheduledSubTransaction } from './ScheduledSubTransaction';
import type { ScheduledTransactionSummary } from './ScheduledTransactionSummary';
import type { SubTransaction } from './SubTransaction';
import type { TransactionSummary } from './TransactionSummary';
/**
 *
 * @export
 * @interface BudgetDetailAllOf
 */
export interface BudgetDetailAllOf {
    /**
     *
     * @type {Array<Account>}
     * @memberof BudgetDetailAllOf
     */
    accounts?: Array<Account>;
    /**
     *
     * @type {Array<Payee>}
     * @memberof BudgetDetailAllOf
     */
    payees?: Array<Payee>;
    /**
     *
     * @type {Array<PayeeLocation>}
     * @memberof BudgetDetailAllOf
     */
    payee_locations?: Array<PayeeLocation>;
    /**
     *
     * @type {Array<CategoryGroup>}
     * @memberof BudgetDetailAllOf
     */
    category_groups?: Array<CategoryGroup>;
    /**
     *
     * @type {Array<Category>}
     * @memberof BudgetDetailAllOf
     */
    categories?: Array<Category>;
    /**
     *
     * @type {Array<MonthDetail>}
     * @memberof BudgetDetailAllOf
     */
    months?: Array<MonthDetail>;
    /**
     *
     * @type {Array<TransactionSummary>}
     * @memberof BudgetDetailAllOf
     */
    transactions?: Array<TransactionSummary>;
    /**
     *
     * @type {Array<SubTransaction>}
     * @memberof BudgetDetailAllOf
     */
    subtransactions?: Array<SubTransaction>;
    /**
     *
     * @type {Array<ScheduledTransactionSummary>}
     * @memberof BudgetDetailAllOf
     */
    scheduled_transactions?: Array<ScheduledTransactionSummary>;
    /**
     *
     * @type {Array<ScheduledSubTransaction>}
     * @memberof BudgetDetailAllOf
     */
    scheduled_subtransactions?: Array<ScheduledSubTransaction>;
}
/**
 * Check if a given object implements the BudgetDetailAllOf interface.
 */
export declare function instanceOfBudgetDetailAllOf(value: object): boolean;
export declare function BudgetDetailAllOfFromJSON(json: any): BudgetDetailAllOf;
export declare function BudgetDetailAllOfFromJSONTyped(json: any, ignoreDiscriminator: boolean): BudgetDetailAllOf;
export declare function BudgetDetailAllOfToJSON(value?: BudgetDetailAllOf | null): any;
