/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Account } from './Account';
import type { CurrencyFormat } from './CurrencyFormat';
import type { DateFormat } from './DateFormat';
/**
 *
 * @export
 * @interface BudgetSummary
 */
export interface BudgetSummary {
    /**
     *
     * @type {string}
     * @memberof BudgetSummary
     */
    id: string;
    /**
     *
     * @type {string}
     * @memberof BudgetSummary
     */
    name: string;
    /**
     * The last time any changes were made to the budget from either a web or mobile client
     * @type {string}
     * @memberof BudgetSummary
     */
    last_modified_on?: string;
    /**
     * The earliest budget month
     * @type {string}
     * @memberof BudgetSummary
     */
    first_month?: string;
    /**
     * The latest budget month
     * @type {string}
     * @memberof BudgetSummary
     */
    last_month?: string;
    /**
     *
     * @type {DateFormat}
     * @memberof BudgetSummary
     */
    date_format?: DateFormat | null;
    /**
     *
     * @type {CurrencyFormat}
     * @memberof BudgetSummary
     */
    currency_format?: CurrencyFormat | null;
    /**
     * The budget accounts (only included if `include_accounts=true` specified as query parameter)
     * @type {Array<Account>}
     * @memberof BudgetSummary
     */
    accounts?: Array<Account>;
}
/**
 * Check if a given object implements the BudgetSummary interface.
 */
export declare function instanceOfBudgetSummary(value: object): boolean;
export declare function BudgetSummaryFromJSON(json: any): BudgetSummary;
export declare function BudgetSummaryFromJSONTyped(json: any, ignoreDiscriminator: boolean): BudgetSummary;
export declare function BudgetSummaryToJSON(value?: BudgetSummary | null): any;
