/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface HybridTransactionAllOf
 */
export interface HybridTransactionAllOf {
    /**
     * Whether the hybrid transaction represents a regular transaction or a subtransaction
     * @type {string}
     * @memberof HybridTransactionAllOf
     */
    type: HybridTransactionAllOfTypeEnum;
    /**
     * For subtransaction types, this is the id of the parent transaction.  For transaction types, this id will be always be null.
     * @type {string}
     * @memberof HybridTransactionAllOf
     */
    parent_transaction_id?: string | null;
    /**
     *
     * @type {string}
     * @memberof HybridTransactionAllOf
     */
    account_name: string;
    /**
     *
     * @type {string}
     * @memberof HybridTransactionAllOf
     */
    payee_name?: string | null;
    /**
     * The name of the category.  If a split transaction, this will be 'Split'.
     * @type {string}
     * @memberof HybridTransactionAllOf
     */
    category_name?: string;
}
/**
 * @export
 */
export declare const HybridTransactionAllOfTypeEnum: {
    readonly Transaction: "transaction";
    readonly Subtransaction: "subtransaction";
};
export type HybridTransactionAllOfTypeEnum = typeof HybridTransactionAllOfTypeEnum[keyof typeof HybridTransactionAllOfTypeEnum];
/**
 * Check if a given object implements the HybridTransactionAllOf interface.
 */
export declare function instanceOfHybridTransactionAllOf(value: object): boolean;
export declare function HybridTransactionAllOfFromJSON(json: any): HybridTransactionAllOf;
export declare function HybridTransactionAllOfFromJSONTyped(json: any, ignoreDiscriminator: boolean): HybridTransactionAllOf;
export declare function HybridTransactionAllOfToJSON(value?: HybridTransactionAllOf | null): any;
